
#include "RelationTable.h"
#include "Relation.h"
#include "View.h"

/* Value relation will have to wit for another day... */


Relation *RelationTable::relation(const char *name)
{
   return ((Relation *) get(name)) ;
}

Relation *RelationTable::create(const char *name, int fixedSize,
                                 View *farView)
{
   Relation *re = (Relation *) get(name) ;

   if (re->isNil()) {
      int mlen = m_enclosingView->indexSet()->maxLength() ;
      Relation *entry = new Relation(name, mlen, fixedSize, farView) ;
      TableBase::add(entry) ;
      return entry ;
   }
   else {
      if ((farView == re->value().otherView) &&
          (fixedSize == re->value().size)) {
#if DEBUG
         if (VErrGetMask() & VERR_RECREATED) {
             char msg[80] ;
             sprintf(msg, "Relation %s being recreated...", name) ;
             VErrWarn(msg, VERR_RECREATED) ;
         }
#endif
      }
      else {
         if (VErrGetMask() & VERR_AMBIGUOUS_CREATE) {
            char msg[120] ;
            sprintf(msg,
            "Recreation of Relation %s is ambiguous due to farView or size",
                    name) ;
            VErrFatal(msg, VERR_AMBIGUOUS_CREATE) ;
         }
      }
      return re ;
   }
}

