#ifndef __RELATIONTABLE_H
#define __RELATIONTABLE_H

#include "Vista.h"
#include "TableBase.h"

///
/// The class which provides hashtable management for Relations.
/// RelationTable contains two hash tables, itemTable and attrTable.  The
/// itemTable returns Relations given the name of the relation as a key.  The
/// attrTable returns a Group given the name of an attribute.  This Group
/// contains a GroupPrivate which is an array of pointers which  points to the
/// Relations in itemTable having the attribute associated with the group.  In
/// this way, RelationTable provides a means to quickly access relations either
/// by name or by attribute from the same class.
///
class RelationTable : public TableBase {
public:
               RelationTable ( View* v, TableBase* parent );
              ~RelationTable ( );
   Relation*   relation ( const char* name );
   Relation*   create ( const char* name, int fixedSize
                      , View* otherView = NIL
                      );
};

inline RelationTable::RelationTable ( View* v, TableBase* parent
                                    ) : TableBase(v, parent, RelationItem)
{
}

inline RelationTable::~RelationTable ( )
{
}

#endif /* __RELATIONTABLE_H */

