
/************************************************************************
 * File    : VErr.c
 * Purpose : Allow user to register an error handler
 ************************************************************************/

#include "VErr.h"

/* Do nothing by default */
/* arguments are name, error level, error type */
static void DefaultHandler(const char *, int, int)
{
   return ;
}

static void (*errHandler)(const char *, int, int) = DefaultHandler ;
int vistaErrMask = 0 ;  /* no errors are enabled by default */


void VErrHandler(void (*f)(const char *, int, int))
{
   if (f == 0)
      errHandler = DefaultHandler ;
   else
      errHandler = f ;

   return ;
}

void VErrWarn(const char *msg, int error)
{
   errHandler(msg, VERR_WARN, error) ;
}

void VErrFatal(const char *msg, int error)
{
   errHandler(msg, VERR_FATAL, error) ;
}

