/**************************************************************************
  Module:  HashADT
  Purpose: Hash table implementation for Zonevar variables with some of
           the code also being used for the Scalars_t hash table.
 ***************************************************************************/

#ifndef __VALUEBASE_H
#define __VALUEBASE_H

#include "Vista.h"

///
/// The base class for the private "value" data of KeyBase and classes derived
/// from it (i.e. View, Relation, Field, Param, Group, Attr).
///
class ValueBase {
   /* The info below is getting out of hand.  The alternative is to */
   /* have the value point to the parent item, the parent item point */
   /* to the parent table, the parent table point to the parent view, */
   /* and the parent view poin to the root view.  The other alternative */
   /* is to redesign everything AGAIN...  (isn't six redesigns enough?) */
public:
             ValueBase ( KeyBase *creatorItem );
   virtual  ~ValueBase ( );

public:
   KeyBase *m_creatorItem;  ///< Points to this Value's creating KeyBase Item.
                            ///< If this value is owned by multiple Items
                            ///< and the original owner is deleted, bad mojo.
   int      m_valueCount;   ///< Number of keys that reference this value.
   MetaType m_valueType;    ///< metaType of this Value (ie Field, Param, etc.)
};

inline ValueBase::ValueBase ( KeyBase *creatorItem ) :
                  m_creatorItem(creatorItem),
                  m_valueCount(1),
                  m_valueType(NullItem)
{
}

inline ValueBase::~ValueBase ( )
{  /* nothing to do here. */ }

#endif /* __VALUEBASE_H */
