
#include "ViewTable.h"
#include "View.h"

static View empty("Nil", new IndexSet(0, NIL)) ;

View *ViewTable::view(const char *name)
{
   View *ve = (View *) get(name) ;
   return (ve->isNil() ? &empty : ve) ;
}

View *ViewTable::create(const char *name, IndexSet *is)
{
   View *ve = (View *) get(name) ;

   if (ve->isNil()) {
      View *entry = new View(name, is, this) ;
      TableBase::add(entry) ;
      return entry ;
   }
   else {
      if (VErrGetMask() & VERR_AMBIGUOUS_CREATE) {
         char msg[120] ;
         sprintf(msg,
                 "Recreation of View %s is ambiguous (remap or destroy?)",
                 name) ;
         VErrFatal(msg, VERR_AMBIGUOUS_CREATE) ;
      }
      return ve ;
   }
}

