
#ifndef __VIEWTABLE_H
#define __VIEWTABLE_H

#include "Vista.h"
#include "TableBase.h"

///
/// The class which provides hashtable management for Views.
/// ViewTable contains two hash tables, itemTable and attrTable.  The itemTable
/// returns Views given the name of the view as a key.  The attrTable returns
/// a Group given the name of an attribute.  This Group contains a GroupPrivate
/// which is an array of pointers which  points to the Views in itemTable having
/// the attribute associated with the group.  In this way, ViewTable provides a
/// means to quickly access Views either by name or by attribute from the same
/// class.
///
class ViewTable : public TableBase {
public:
           ViewTable ( View *v, TableBase *parent );
          ~ViewTable ( );
   View*   create(const char *name, IndexSet *is) ;
   View*   view(const char *name) ;
} ;

inline ViewTable::ViewTable ( View *v, TableBase *parent
                            ) : TableBase(v, parent, ViewItem)
{
}

inline ViewTable::~ViewTable ( )
{
}

#endif /* __VIEWTABLE_H */

