/************************************************************************
 * File    : Vista.h
 * Purpose : Contains DataType declarations for vista.
 *           Also contains a few macros.
 ************************************************************************/

#ifndef __VISTA_H
#define __VISTA_H

/**************************
 *      Basic Types       *
 **************************/

typedef double real8 ;

#if 0
typedef real8 Real ;
typedef int Integer ;
typedef unsigned int Index ;
/* typedef real8 MatrixEntry ; */
#endif

enum MetaType
{
   NullItem, ViewItem, ParamItem, FieldItem, RelationItem, GroupItem,
   AttrItem
} ;

enum OTCDataType { OTC_UNKNOWN, OTC_STRING, OTC_INT, OTC_REAL } ;

/* typedef DSL_Type DataType ; */
typedef OTCDataType DataType ;


/**************************
 * Forward Declarations   *
 **************************/

class Attr ;
class Group ;
class IndexSet ;
class View ;
class Param ;
class Field ;
class Relation ;
class ViewTable ;
class ParamTable ;
class FieldTable ;
class RelationTable ;
class KeyBase ;
class ValueBase ;
class TableBase ;
class VHashTable ;
class VHashTraverse ;

/**************************
 *      Macros            *
 **************************/

#define NIL 0

#define Streq(s1, s2) (strcmp((s1), (s2)) == 0)

#ifndef MIN
#define MIN(a, b) (((a)<(b))?(a):(b))
#endif

#ifndef MAX
#define MAX(a, b) (((a)>(b))?(a):(b))
#endif

/* This macro is used to indicate whether the databas or the
   application owns the data by default.
 */
#define VISTA_OWNS  true

#endif /* __VISTA_H */
